<?xml version="1.0" encoding="iso-8859-1"?>
<iso:schema    xmlns="http://purl.oclc.org/dsdl/schematron" 
	       xmlns:iso="http://purl.oclc.org/dsdl/schematron"
	       xmlns:nrgxsl="http://nrg.wustl.edu/validate" 
	       queryBinding='xslt2'
	       schemaVersion="ISO19757-3">
<iso:ns uri="http://nrg.wustl.edu/xnat" prefix="xnat"/>
  <iso:title>Protocol Validator</iso:title>
  <iso:pattern id="Start">
	   <iso:title>Validation report</iso:title>
	    <iso:rule context="/">
	     	<iso:assert test="xnat:MRSession">The root element must be an MRSession</iso:assert>
	    </iso:rule>
	    <iso:rule context="xnat:MRSession">
		<iso:report id="expt_id" test="true()"><iso:value-of select="@ID"/></iso:report>
		<iso:report id="expt_project" test="true()"><iso:value-of select="@project"/></iso:report>
	    </iso:rule>
 </iso:pattern>
 <iso:pattern id="Acquisition">
	    <iso:rule context="xnat:scans">
		<iso:assert test="count(xnat:scan[@type='localizer']) >= 3"> 
		<nrgxsl:acquisition>
		  MRSession must have alteast 3 localizer scan found <iso:value-of select="count(xnat:scan[@type='localizer'])"/> 
		</nrgxsl:acquisition> 
		</iso:assert>
            </iso:rule>
 </iso:pattern>
<iso:pattern id="ListScanIds">
	    <iso:rule context="//xnat:scan">
		<iso:report test="@ID">
		  <nrgxsl:scans>
		    <iso:value-of select="@ID"/>
		  </nrgxsl:scans> 	
		</iso:report>
            </iso:rule>
 </iso:pattern>
  <iso:pattern id="Scan">
		<iso:rule context="xnat:scan[@type='localizer']">
			<iso:assert test="xnat:frames = 176" >
			   <nrgxsl:scan>
			      <nrgxsl:scan-id><iso:value-of select="@ID"/></nrgxsl:scan-id>
			      <iso:value-of select="concat( ' Number of frames must be 176 found ', ./xnat:frames)"/>
			   </nrgxsl:scan>
			</iso:assert>
			<iso:assert test="xnat:parameters/xnat:tr = 2400" >
			   <nrgxsl:scan>
			      <nrgxsl:scan-id><iso:value-of select="@ID"/></nrgxsl:scan-id>
			   <iso:value-of select="concat(' TR value should be 2400 found ', ./xnat:parameters/xnat:tr)"/>
			   </nrgxsl:scan>
			</iso:assert>
			<iso:assert test="xnat:parameters/xnat:te = 3.2" >
			   <nrgxsl:scan>
			      <nrgxsl:scan-id><iso:value-of select="@ID"/></nrgxsl:scan-id>
			   <iso:value-of select="concat('TE value should be 3.2 found ', ./xnat:parameters/xnat:te)"/>
			   </nrgxsl:scan>
			</iso:assert>
		</iso:rule>
		<iso:rule context="xnat:scan[@type='localizer_aligned']">
			<iso:assert test="xnat:parameters/xnat:te = 3.2" > 
			   <nrgxsl:scan>
			      <nrgxsl:scan-id><iso:value-of select="@ID"/></nrgxsl:scan-id>
			    <iso:value-of select="concat('TE value should be 3.2 found ', ./xnat:parameters/xnat:te)"/>
			   </nrgxsl:scan>
			 </iso:assert>
		</iso:rule>
 </iso:pattern>

</iso:schema>
